﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace Karela
{
    public partial class box : Form
    {
        PictureBox p;               //Picture box
        Image image;                //Current image in picture box
        int row, col;               //row and column of picture box
        bool blocked;               //Indicates if picture box is blocked
        bool painted;               //Indicates if picture box is painted
        Image paint = Prototype.Properties.Resources.painted;
        Image blank = Prototype.Properties.Resources.white;
        public box() //Set defaults for box
        {
            image = blank;
            row = 0;
            col = 0;
            blocked = false;
            painted = false;

        }

       public box(PictureBox x, int r, int c) //Set picture box and location from constructor
        {
            p = x;
            image = blank;
            row = r;
            col = c;
            blocked = false;
            painted = false;

        }

        public void reset() //Reset the image to blank if not blocked
        {
            if (!blocked)
            {
                image = blank;
                p.Image = blank;
            }
            painted = false;
        }

        //Set and get picture box
        public void setPictureBox(PictureBox x) { p = x; }
        public PictureBox getPictureBox() { return p; }

        //Set and get image
        public void setImage(Image s)
        {
            p.Image = s;
        }

        public Image getImage()
        {
            return image;
        }

        //Set and get if box is painted
        public bool getPaint()
        {
            return painted;
        }

        public void setPaint()
        {
            if (painted)
            {
                painted = false;
            }
            else { painted = true; }
        }


        //Set and get row and column
        public int getRow() { return row; }
        public int getCol() { return col; }
        public void setRow(int r) { row = r; }
        public void setCol(int c) { col = c; }

        //Set and get if box is blocked
        public void setBlocked()
        {
            if (blocked)
            {
                blocked = false;
            }
            else
            {
                blocked = true;
            }
        }
        public bool getBlocked() { return blocked; }
    }
}
