﻿using System;
using System.Windows.Forms;

namespace Karela
{
    public partial class Lesson : Form
    {
        int lessonNumber = 1;                         //Current lesson displayed
        string lesson = Prototype.Properties.Resources.Lessons; //Lessons from text file
        string[] lessons;                             //Stores separate lesson
        string[] lessonTitle = new string[8];         //Stores lesson titles
        string[] lessonText = new string[8];          //Stores lesson texts
        string[] lessonProg = new string[8];          //Stores lesson programs

        private main mainForm;
        public Lesson(main mf, int lessonNum)
        {
            InitializeComponent();
            lessons = lesson.Split('%'); //Split lesson
            int c = 0; //Current lesson to place in arrays
            for(int i = 0; i < lessons.Length; i = i+3) //Iterate through lessons to get title, text and prog
            {
               
               lessonTitle[c] = lessons[i];
               lessonText[c] = lessons[i + 1];
               lessonProg[c] = lessons[i + 2].ToLower();
               c++;
            }

            this.mainForm = mf;
            lessonNumber = lessonNum; //Setting lesson number from main form
            labelLTitle.Text = lessonTitle[lessonNumber];
            labelLProg.Text = lessonProg[lessonNumber];
            labelLText.Text = lessonText[lessonNumber];

        }

        //************************************* 
        // Running the lesson program
        //************************************
        private void buttonlRun_Click(object sender, EventArgs e)
        {
           //Disable buttons
           buttonLRun.Enabled = false;
           buttonlReset.Enabled = false;
           buttonlStep.Enabled = false;

           //Set variables in main form
           mainForm.progSet = true;
           mainForm.fromLesson = true;
           mainForm.prog = labelLProg.Text.Split('\n');

           //Call run from main form
           mainForm.buttonRun_Click(sender, e);

           //Enable buttons
           buttonLRun.Enabled = true;
           buttonlReset.Enabled = true;
           buttonlStep.Enabled = true;
        }

        private void buttonlStep_Click(object sender, EventArgs e)
        {
            //Disable buttons
            buttonLRun.Enabled = false;
            buttonlReset.Enabled = false;
            buttonlStep.Enabled = false;

            //Set variables in main form
            mainForm.fromLesson = true;
            mainForm.progSet = true;
            mainForm.prog = labelLProg.Text.Split('\n');

            //Call step from main form
            mainForm.buttonStep_Click(sender, e);

            //Enable buttons
            buttonLRun.Enabled = true;
            buttonlReset.Enabled = true;
            buttonlStep.Enabled = true;

        }

        private void buttonlReset_Click(object sender, EventArgs e)
        {
            //Disable buttons
            buttonLRun.Enabled = false;
            buttonlReset.Enabled = false;
            buttonlStep.Enabled = false;

            //Call reset from main form
            mainForm.buttonReset_Click(sender, e);

            //Enable buttons
            buttonLRun.Enabled = true;
            buttonlReset.Enabled = true;
            buttonlStep.Enabled = true;
        }


        //************************************* 
        // Enabling and disabling buttons on focus change
        //************************************
        private void lesson_Activate(object sender, EventArgs e)
        {
            buttonLRun.Enabled = true;
            buttonlReset.Enabled = true;
            buttonlStep.Enabled = true;
            mainForm.fromLesson = true;
            
        }

        private void lesson_Deactivate(object sender, EventArgs e)
        {
            buttonLRun.Enabled = false;
            buttonlReset.Enabled = false;
            buttonlStep.Enabled = false;
           
        }


        //************************************* 
        // Traversing lessons
        //************************************
        private void buttonLnext_Click(object sender, EventArgs e)
        {
            lessonNumber = lessonNumber+1; //Increase lesson number
            if (lessonNumber < 8) //Change lesson displayed if not out of range
            {
                labelLTitle.Text = lessonTitle[lessonNumber];
                labelLProg.Text = lessonProg[lessonNumber];
                labelLText.Text = lessonText[lessonNumber];
            }
            else //Reset to the first lesson
            {
                lessonNumber = 0;
                labelLTitle.Text = lessonTitle[lessonNumber];
                labelLProg.Text = lessonProg[lessonNumber];
                labelLText.Text = lessonText[lessonNumber];
            }
        }

        private void buttonLprev_Click(object sender, EventArgs e)
        {
            if (lessonNumber-- > 0) //Change lesson displayed if not out of range
            {
                lessonNumber = lessonNumber--;
                labelLTitle.Text = lessonTitle[lessonNumber];
                labelLProg.Text = lessonProg[lessonNumber];
                labelLText.Text = lessonText[lessonNumber];
            }
            else //Reset to the last lesson
            {
                lessonNumber = 7;
                labelLTitle.Text = lessonTitle[lessonNumber];
                labelLProg.Text = lessonProg[lessonNumber];
                labelLText.Text = lessonText[lessonNumber];
            }
        }
    }
}
