﻿using System;
using System.Drawing;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;



namespace Karela
{
    public partial class main : Form
    {
        //************************************* 
        //Running Loops and If statement variables
        //************************************
        static bool forLoop = false;                   //If the program is running a for loop
        static string condition = "";                  //Condition that needs to be met for loop
        static string[] x;                             //holds split conditions from statements
        static bool greaterthan = false;               //Show whether for loop is greater than or less than
        static int startValue = 0;                     //Starting value for a for loop
        static bool up = true;                         //Whether to increment up or down for a for loop
        static int loopVariable = 0;                   //The varible used to increment a for loop
        static bool runElse = false;                   //Indicates whether or not the else needs to run


        //************************************* 
        //General running of program 
        //************************************
        int line = 0;                                  //Current line number being run
        int startIndex = 0;                            //Index used for highlighting text
        static String s;                               //Stores text from RTB
        public String[] prog;                          //Stores split program
        static int[,] compoundStatements = new int[10, 4]; //Keeps track of line nums for beginning and end of statements
        public bool progDone = false;                  //Indicates whether the program has run completely or not
        static bool error = false;                     //Indicates if prog has stopped due to an error
        public bool progSet = false;                   //Indicates if prog was already set in the lessson form
        int progLength = 0;                            //Length of the program
        int tableCol = 0;                              //Column in compoundStatement table
        int tableRow = 0;                              //Row in compoundStatement table
        public bool fromLesson = false;                // Shows if coming from lesson form

        //************************************* 
        // Variables to keep track of place in grid and program
        //************************************

        box[,] grid = new box[7, 7];                   //Array to keep track of picture boxes in grid
        static int activeRow = 6;                      //Row that Karela is on
        static int activeColumn = 0;                   //Column that Karela is on
        int direction = 1;                      //Direction Karela is facing
        int gridSize = 7;                              //Size of grid

        //************************************* 
        // Variables for saving/opening files and opening lessons
        //************************************
        int lesson = 1;                   //Indicates what number lesson is selected  
        bool fileModified = false;        //Indicates if a program has been modified
        string fileName = "Untitled";     //Default file name


        //************************************* 
        // Image variables
        //************************************
        Image karela = Prototype.Properties.Resources.karela;
        Image blank = Prototype.Properties.Resources.white;
        Image block = Prototype.Properties.Resources.blocked;
        Image KarelaPaint = Prototype.Properties.Resources.KarelaPainted;
        Image painted = Prototype.Properties.Resources.painted;

        public main()
        {
            InitializeComponent();
            labelAction.Text = "";

            //Programmatically create pictureboxes in grid
            for (int i = 0; i < gridSize; i++)
            {
                for (int j = 0; j < gridSize; j++)
                {
                    PictureBox p = new PictureBox();

                    p.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                    | System.Windows.Forms.AnchorStyles.Left)
                    | System.Windows.Forms.AnchorStyles.Right)));
                    p.Image = blank;
                    p.Size = new System.Drawing.Size(119, 118);
                    p.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
                    p.Click += new System.EventHandler(this.pictureBox_block);
                    grid[i, j] = new box(p, i, j);
                }
            }
        }

        private void main_Load(object sender, EventArgs e)
        {

            //Add pictureboxes to table layout
            for (int i = 0; i < gridSize; i++)
            {
                for (int j = 0; j < gridSize; j++)
                {
                    tableLayoutPanelGrid.Controls.Add(grid[i, j].getPictureBox(), j, i);
                }
            }

            //Set bottom corner as active image
            grid[6, 0].setImage(karela);

        }


        //Blocks a picturebox when clicked
        private void pictureBox_block(object sender, EventArgs e)
        {
            
                PictureBox pb = (PictureBox)sender;


                if (pb.Parent.Equals(tableLayoutPanelGrid))
                {
                
                    int r = tableLayoutPanelGrid.GetRow(pb);
                    int c = tableLayoutPanelGrid.GetColumn(pb);
                if (r != activeRow || c != activeColumn)
                {
                    if (grid[r, c].getBlocked())
                    {
                        pb.Image = blank;
                        grid[r, c].setBlocked();
                    }
                    else
                    {
                        pb.Image = block;
                        grid[r, c].setBlocked();
                    }
                }

                }
            

        }


        //************************************* 
        // Dragging events
        //************************************
        private void RTBProg_DragEnter(object sender, DragEventArgs e)
        {
            RTBprog.Focus();
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                e.Effect = DragDropEffects.Copy;
            }
        }
        private void RTBProg_DragDrop(object sender,
        System.Windows.Forms.DragEventArgs e)
        {


            RTBprog.Focus();
            int index = RTBprog.GetCharIndexFromPosition(RTBprog.PointToClient(Cursor.Position));
            RTBprog.SelectionStart = index;
            RTBprog.SelectionLength = 0;
            Point cp = RTBprog.GetPositionFromCharIndex(index);
            char c = RTBprog.GetCharFromPosition(cp);
            
            //If statements to determine if new line should be entered 
            if (RTBprog.GetCharFromPosition(cp) == '\0')
            {
               
                RTBprog.Text = RTBprog.Text.Insert(RTBprog.SelectionStart, e.Data.GetData(DataFormats.Text).ToString());

            }
            else if (RTBprog.GetCharFromPosition(cp) == '\n')
            {
              
                RTBprog.Text = RTBprog.Text.Insert(RTBprog.SelectionStart + 1, e.Data.GetData(DataFormats.Text).ToString());

            }
            else
            {
                
                RTBprog.Text = RTBprog.Text.Insert(RTBprog.SelectionStart, e.Data.GetData(DataFormats.Text).ToString());
            }
            RTBprog.Select(RTBprog.Text.Length, 0);

        }
        private void pictureBox_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
        {

            //Assign action name to be dropped into textbox
            PictureBox pb = (PictureBox)sender;
            if (pb.Name == "pictureBoxMove")
            {
                pb.DoDragDrop("Move\n", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxTurnLeft")
            {
                pb.DoDragDrop("TurnLeft\n", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxTurnRight")
            {
                pb.DoDragDrop("TurnRight\n", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxTurnAround")
            {
                pb.DoDragDrop("TurnAround\n", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxPaint")
            {
                pb.DoDragDrop("Paint\n", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxErase")
            {
                pb.DoDragDrop("Erase\n", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxWhile")
            {
                pb.DoDragDrop("while(){ \n}\n", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxFor")
            {
                pb.DoDragDrop("for( : : ){\n}\n", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxIf")
            {
                pb.DoDragDrop("if( ){\n}\n", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxIfElse")
            {
                pb.DoDragDrop("if( ){\n}\nElse{\n}\n", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxPainted")
            {
                pb.DoDragDrop("isPainted", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxNotPainted")
            {
                pb.DoDragDrop("notPainted", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxNotBlocked")
            {
                pb.DoDragDrop("notBlocked", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxLeftBlocked")
            {
                pb.DoDragDrop("leftBlocked", DragDropEffects.All);

            }
            else if (pb.Name == "pictureBoxRightBlocked")
            {
                pb.DoDragDrop("rightBlocked", DragDropEffects.All);
            }
            else if (pb.Name == "pictureBoxBehindBlocked")
            {
                pb.DoDragDrop("behindBlocked", DragDropEffects.All);
            }
        }


        //************************************* 
        // Running the user's program
        //************************************
        
        //Split program if not done in lesson
        public void setProg()
        {
            s = RTBprog.Text.ToString().ToLower();
            prog = s.Split('\n');

        }

        //When run is clicked
        public void buttonRun_Click(object sender, EventArgs e)
        {
           
            //Disable buttons and get program
            buttonRun.Enabled = false;
            buttonReset.Enabled = false;
            RTBprog.Enabled = false;
            buttonStep.Enabled = false;

            //Check is program was set in lesson
            if (!progSet)
            {
                setProg();
            }

            //Set bools
            forLoop = false;
            greaterthan = false;
            startValue = 0;
            up = true;
            
                //Reset the grid before starting new program
                resetGrid();
                tableLayoutPanelGrid.BackColor = Color.Green; //Indicate that prog is running
                int startIndex = 0; //Start value for highlighting

                //Create table of compound statements
                preCompile();

                //Check if returing from lesson
                if (fromLesson)
                {
                    runLesson(); //Runs without highlighting in textbox
                }
                else
                {
                    runHighlight(); //Runs with highlighting in textbox
                }

               
                line = 0;

        }

        //When step is clicked
        public async void buttonStep_Click(object sender, EventArgs e)
        {

            //Disable buttons and get program
            tableLayoutPanelGrid.BackColor = Color.Green;
            buttonRun.Enabled = false;
            buttonReset.Enabled = false;
            RTBprog.Enabled = false;
            buttonStep.Enabled = false;

            //Check is prog was set in lesson
            if (!progSet)
            {
                setProg();
            }
            string progItem;

            if(line == 0) //Precompiles if start of the prog
            {
                preCompile(); //Gets compound statements
            }

            if (progDone)  //If program is complete then reset values and grid
            {
                resetGrid();
                progDone = false;
                line = 0;
            }
            else
            {

                if (line < prog.Length && !error) //Check that program isn't complete
                {
                    progItem = prog[line];
                    if (progItem != " " && progItem != "" && progItem != "\r" && progItem != "\n")
                    {
                        if (inTable(line)) //Check if line is in compound statement table
                        {
                            if (!fromLesson) //Check if from lesson 
                            {
                                startIndex = RTBprog.GetFirstCharIndexFromLine(line);
                                RTBprog.Select(startIndex, RTBprog.Lines[line].Length);
                                RTBprog.SelectionBackColor = System.Drawing.Color.Yellow;
                            }
                            labelAction.Text = "Running: " + progItem;

                            if (tableCol == 1) //Check if it is a while
                            {
                                if (compoundStatements[returnRow(line), 0] == 1) //Start of a while loop
                                {
                                    x = progItem.Split('('); //Get condition
                                    condition = x[1];

                                    //Check if condition is true and assign line
                                    if (condition.Contains("notblocked"))
                                    {
                                        if (moveIsValid())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            line = compoundStatements[returnRow(line), 2] + 1;
                                        }

                                    }
                                    else if (condition.Contains("ispainted"))
                                    {
                                        if (grid[activeRow, activeColumn].getPaint())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            line = compoundStatements[returnRow(line), 2] + 1;
                                        }

                                    }
                                    else if (condition.Contains("notpainted"))
                                    {
                                        if (!grid[activeRow, activeColumn].getPaint())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            line = compoundStatements[returnRow(line), 2] + 1;
                                        }

                                    }
                                    else if (condition.Contains("leftblocked"))
                                    {
                                        if (direction == 1)
                                        {
                                            if (grid[activeRow - 1, activeColumn].getBlocked())
                                            {
                                                line++;
                                            }
                                            else
                                            {
                                                line = compoundStatements[returnRow(line), 2] + 1;
                                            }
                                        }
                                        else if (direction == 2)
                                        {
                                            if (grid[activeRow, activeColumn - 1].getBlocked())
                                            {
                                                line++;
                                            }
                                            else
                                            {
                                                line = compoundStatements[returnRow(line), 2] + 1;
                                            }
                                        }
                                        else if (direction == 3)
                                        {
                                            if (grid[activeRow + 1, activeColumn].getBlocked())
                                            {
                                                line++;
                                            }
                                            else
                                            {
                                                line = compoundStatements[returnRow(line), 2] + 1;
                                            }
                                        }
                                        else
                                        {
                                            if (grid[activeRow, activeColumn + 1].getBlocked())
                                            {
                                                line++;
                                            }
                                            else
                                            {
                                                line = compoundStatements[returnRow(line), 2] + 1;
                                            }
                                        }

                                    }
                                }
                                else if (compoundStatements[returnRow(line), 0] == 2) //Start of an if statement
                                {

                                    x = progItem.Split('('); //Get condition
                                    condition = x[1];

                                    //Check if condition is true
                                    if (condition.Contains("notblocked"))
                                    {
                                        if (moveIsValid())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            runElse = true;
                                            line = compoundStatements[returnRow(line), 2];
                                        }

                                    }
                                    else if (condition.Contains("ispainted"))
                                    {
                                        if (grid[activeRow, activeColumn].getPaint())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            runElse = true;
                                            line = compoundStatements[returnRow(line), 2];
                                        }

                                    }
                                    else if (condition.Contains("notpainted"))
                                    {
                                        if (!grid[activeRow, activeColumn].getPaint())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            runElse = true;
                                            line = compoundStatements[returnRow(line), 2];
                                        }

                                    }
                                    else if (condition.Contains("leftblocked"))
                                    {
                                        if (direction == 1)
                                        {
                                            if (grid[activeRow - 1, activeColumn].getBlocked())
                                            {
                                                line++;
                                            }
                                            else
                                            {
                                                runElse = true;
                                                line = compoundStatements[returnRow(line), 2];
                                            }
                                        }
                                        else if (direction == 2)
                                        {
                                            if (grid[activeRow, activeColumn - 1].getBlocked())
                                            {
                                                line++;
                                            }
                                            else
                                            {
                                                runElse = true;
                                                line = compoundStatements[returnRow(line), 2];
                                            }
                                        }
                                        else if (direction == 3)
                                        {
                                            if (grid[activeRow + 1, activeColumn].getBlocked())
                                            {
                                                line++;
                                            }
                                            else
                                            {
                                                runElse = true;
                                                line = compoundStatements[returnRow(line), 2];
                                            }
                                        }
                                        else
                                        {
                                            if (grid[activeRow, activeColumn + 1].getBlocked())
                                            {
                                                line++;
                                            }
                                            else
                                            {
                                                runElse = true;
                                                line = compoundStatements[returnRow(line), 2];
                                            }
                                        }

                                    }
                                }
                                else if (compoundStatements[returnRow(line), 0] == 3) //Start of an else statement
                                {
                                    if (!runElse) //Go to end of else if it shouldn't be run
                                    {
                                        line = compoundStatements[returnRow(line), 2] + 1;
                                    }
                                    else //Goes to next line to run else
                                    {
                                        line++;
                                    }

                                }
                                else //If a for loop
                                {
                                    if (!forLoop) //If start of a for loop
                                    {
                                        //Set bool and get values for for loop
                                        forLoop = true; 
                                        x = progItem.Split(':');
                                        condition = x[1];
                                        string y = x[0];
                                        startValue = int.Parse(x[0].Split('=')[1]);
                                        if (progItem.Contains('>'))
                                        {
                                            greaterthan = true;
                                        }
                                        else
                                        {
                                            greaterthan = false;
                                        }

                                        if (!progItem.Contains('+'))
                                        {
                                            up = false;
                                        }
                                        else
                                        {
                                            up = true;
                                        }
                                        loopVariable = startValue;
                                        line++;
                                    }
                                    else
                                    {
                                        //Check for loop values and condition
                                        int endCondition = int.Parse(condition.Split('<')[1]);
                                        if (!greaterthan)
                                        {
                                            if (up)
                                            {
                                                loopVariable++;
                                                if (loopVariable > endCondition)
                                                {
                                                    forLoop = false;
                                                    line = compoundStatements[returnRow(line), 2] + 1;
                                                }
                                                else
                                                {
                                                    line++;
                                                }
                                            }
                                            else
                                            {
                                                loopVariable--;
                                                if (loopVariable > endCondition)
                                                {
                                                    forLoop = false;
                                                    line = compoundStatements[returnRow(line), 2] + 1;
                                                }
                                                else
                                                {
                                                    line++;
                                                }
                                            }
                                        }
                                        else
                                        {
                                            if (up)
                                            {
                                                loopVariable++;
                                                if (loopVariable < endCondition)
                                                {
                                                    forLoop = false;
                                                    line = compoundStatements[returnRow(line), 2] + 1;
                                                }
                                                else
                                                {
                                                    line++;
                                                }
                                            }
                                            else
                                            {
                                                loopVariable--;
                                                if (loopVariable < endCondition)
                                                {
                                                    forLoop = false;
                                                    line = compoundStatements[returnRow(line), 2] + 1;
                                                }
                                                else
                                                {
                                                    line++;
                                                }

                                            }
                                        }

                                    }


                                }
                            }
                            else
                            {
                                if (compoundStatements[returnRow(line), 0] == 1) //End of a while
                                {
                                    line = compoundStatements[returnRow(line), 1];
                                }
                                else if (compoundStatements[returnRow(line), 0] == 4) //End of for loop
                                {
                                    line = compoundStatements[returnRow(line), 1];
                                }
                                else
                                {
                                    line = compoundStatements[returnRow(line), 2] + 1;
                                }
                            }
                            await Task.Delay(1000);
                            RTBprog.SelectionBackColor = System.Drawing.Color.Transparent;
                        }
                        else
                        {
                            if (!fromLesson) //Check if from lesson
                            {
                                startIndex = RTBprog.GetFirstCharIndexFromLine(line);
                                RTBprog.Select(startIndex, RTBprog.Lines[line].Length);
                                RTBprog.SelectionBackColor = System.Drawing.Color.Yellow;
                            }

                            //Run the program
                            labelAction.Text = "Running: " + progItem;
                            checkAction(progItem);
                            await Task.Delay(1000);
                            line++;
                            RTBprog.SelectionBackColor = System.Drawing.Color.Transparent;
                        }
                    }
                    else
                    {
                        line++;
                    }
                }
                else
                {
                    if (error)
                    {
                        labelAction.Text = "Error on line: " + line + " " + prog[line];
                    }
                    else
                    {
                        labelAction.Text = "Done Running";
                    }
                    //Enable buttons and reset variables

                    tableLayoutPanelGrid.BackColor = Color.YellowGreen;
                    buttonRun.Enabled = true;
                    buttonReset.Enabled = true;
                    RTBprog.Enabled = true;
                    loopVariable = 0;
                    labelAction.Text = "Done Running";
                    
                    progDone = true;
                    progSet = false;
                    //end of stepping
                }
            }
            buttonStep.Enabled = true;
        }

        //When reset is clicked
        public void buttonReset_Click(object sender, EventArgs e)
        {
            resetGrid();
        }

        //Runs and highlights text
        public async void runLesson()
        {
            buttonRun.Enabled = false;
            buttonReset.Enabled = false;
            RTBprog.Enabled = false;
            buttonStep.Enabled = false;
            await Task.Delay(1000);
            string progItem;
            while (line < progLength)
            {
                progItem = prog[line];
                if (progItem != " " && progItem != "" && progItem != "\r" && progItem != "\n")
                {
                    if (inTable(line))
                    {

                        labelAction.Text = "Running: " + progItem;
                        if (tableCol == 1)
                        {
                            if (compoundStatements[returnRow(line), 0] == 1) //Start of a while loop
                            {
                                x = progItem.Split('('); //Get condition
                                condition = x[1];

                                //Check if condition is true
                                if (condition.Contains("notblocked"))
                                {
                                    if (moveIsValid())
                                    {
                                        line++;
                                    }
                                    else
                                    {
                                        line = compoundStatements[returnRow(line), 2] + 1;
                                    }

                                }
                                else if (condition.Contains("ispainted"))
                                {
                                    if (grid[activeRow, activeColumn].getPaint())
                                    {
                                        line++;
                                    }
                                    else
                                    {
                                        line = compoundStatements[returnRow(line), 2] + 1;
                                    }

                                }
                                else if (condition.Contains("notpainted"))
                                {
                                    if (!grid[activeRow, activeColumn].getPaint())
                                    {
                                        line++;
                                    }
                                    else
                                    {
                                        line = compoundStatements[returnRow(line), 2] + 1;
                                    }

                                }
                                else if (condition.Contains("leftblocked"))
                                {
                                    if (direction == 1)
                                    {
                                        if (grid[activeRow - 1, activeColumn].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            line = compoundStatements[returnRow(line), 2] + 1;
                                        }
                                    }
                                    else if (direction == 2)
                                    {
                                        if (grid[activeRow, activeColumn - 1].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            line = compoundStatements[returnRow(line), 2] + 1;
                                        }
                                    }
                                    else if (direction == 3)
                                    {
                                        if (grid[activeRow + 1, activeColumn].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            line = compoundStatements[returnRow(line), 2] + 1;
                                        }
                                    }
                                    else
                                    {
                                        if (grid[activeRow, activeColumn + 1].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            line = compoundStatements[returnRow(line), 2] + 1;
                                        }
                                    }

                                }
                            }
                            else if (compoundStatements[returnRow(line), 0] == 2) //Start of an if statement
                            {

                                x = progItem.Split('('); //Get condition
                                condition = x[1];

                                //Check if condition is true
                                if (condition.Contains("notblocked"))
                                {
                                    if (moveIsValid())
                                    {
                                        line++;
                                    }
                                    else
                                    {
                                        runElse = true;
                                        line = compoundStatements[returnRow(line), 2];
                                    }

                                }
                                else if (condition.Contains("ispainted"))
                                {
                                    if (grid[activeRow, activeColumn].getPaint())
                                    {
                                        line++;
                                    }
                                    else
                                    {
                                        runElse = true;
                                        line = compoundStatements[returnRow(line), 2];
                                    }

                                }
                                else if (condition.Contains("notpainted"))
                                {
                                    if (!grid[activeRow, activeColumn].getPaint())
                                    {
                                        line++;
                                    }
                                    else
                                    {
                                        runElse = true;
                                        line = compoundStatements[returnRow(line), 2];
                                    }

                                }
                                else if (condition.Contains("leftblocked"))
                                {
                                    if (direction == 1)
                                    {
                                        if (grid[activeRow - 1, activeColumn].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            runElse = true;
                                            line = compoundStatements[returnRow(line), 2];
                                        }
                                    }
                                    else if (direction == 2)
                                    {
                                        if (grid[activeRow, activeColumn - 1].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            runElse = true;
                                            line = compoundStatements[returnRow(line), 2];
                                        }
                                    }
                                    else if (direction == 3)
                                    {
                                        if (grid[activeRow + 1, activeColumn].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            runElse = true;
                                            line = compoundStatements[returnRow(line), 2];
                                        }
                                    }
                                    else
                                    {
                                        if (grid[activeRow, activeColumn + 1].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            runElse = true;
                                            line = compoundStatements[returnRow(line), 2];
                                        }
                                    }

                                }
                            }
                            else if (compoundStatements[returnRow(line), 0] == 3) //Start of an else statement
                            {
                                if (!runElse) //Go to end of else if it shouldn't be run
                                {
                                    line = compoundStatements[returnRow(line), 2] + 1;
                                }
                                else //Goes to next line to run else
                                {
                                    line++;
                                }

                            }
                            else //If a for loop
                            {
                                if (!forLoop)
                                {
                                    forLoop = true;
                                    x = progItem.Split(':');
                                    condition = x[1];
                                    string y = x[0];
                                    startValue = int.Parse(x[0].Split('=')[1]);
                                    if (progItem.Contains('>'))
                                    {
                                        greaterthan = true;
                                    }
                                    else
                                    {
                                        greaterthan = false;
                                    }

                                    if (!progItem.Contains('+'))
                                    {
                                        up = false;
                                    }
                                    else
                                    {
                                        up = true;
                                    }
                                    loopVariable = startValue;
                                    line++;
                                }
                                else
                                {
                                    int endCondition;
                                    if (!greaterthan)
                                    {
                                        endCondition = int.Parse(condition.Split('<')[1]);
                                        if (up)
                                        {
                                            loopVariable++;
                                            if (loopVariable > endCondition)
                                            {
                                                forLoop = false;
                                                line = compoundStatements[returnRow(line), 2] + 1;
                                            }
                                            else
                                            {
                                                line++;
                                            }
                                        }
                                        else
                                        {

                                            loopVariable--;
                                            if (loopVariable > endCondition)
                                            {
                                                forLoop = false;
                                                line = compoundStatements[returnRow(line), 2] + 1;
                                            }
                                            else
                                            {
                                                line++;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        endCondition = int.Parse(condition.Split('>')[1]);
                                        if (up)
                                        {
                                            loopVariable++;
                                            if (loopVariable < endCondition)
                                            {
                                                forLoop = false;
                                                line = compoundStatements[returnRow(line), 2] + 1;
                                            }
                                            else
                                            {
                                                line++;
                                            }
                                        }
                                        else
                                        {
                                            loopVariable--;
                                            if (loopVariable < endCondition)
                                            {
                                                forLoop = false;
                                                line = compoundStatements[returnRow(line), 2] + 1;
                                            }
                                            else
                                            {
                                                line++;
                                            }

                                        }
                                    }

                                }


                            }
                        }
                        else
                        {
                            if (compoundStatements[returnRow(line), 0] == 1) //End of a while
                            {
                                line = compoundStatements[returnRow(line), 1];
                            }
                            else if (compoundStatements[returnRow(line), 0] == 4) //End of for loop
                            {
                                line = compoundStatements[returnRow(line), 1];
                            }
                            else
                            {
                                line = compoundStatements[returnRow(line), 2] + 1;
                            }
                        }
                        await Task.Delay(1000);

                    }
                    else
                    {

                        labelAction.Text = "Running: " + progItem;
                        checkAction(progItem);
                        await Task.Delay(1000);
                        line++;

                    }

                }
                else { line++; }
            }

            tableLayoutPanelGrid.BackColor = Color.YellowGreen;
            buttonRun.Enabled = true;
            buttonReset.Enabled = true;
            buttonStep.Enabled = true;
            RTBprog.Enabled = true;
            labelAction.Text = "Done Running";
            progDone = true;
            progSet = false;


        }

        //Runs without highlighting text
        public async void runHighlight()
        {
           
            await Task.Delay(1000);
            string progItem;


            while (line < progLength && !error)
            {
                progItem = prog[line];
                if (progItem != " " && progItem != "" && progItem != "\r" && progItem != "\n")
                {
                    if (inTable(line))
                    {
                        if (!fromLesson)
                        {
                            startIndex = RTBprog.GetFirstCharIndexFromLine(line);
                            RTBprog.Select(startIndex, RTBprog.Lines[line].Length);
                            RTBprog.SelectionBackColor = System.Drawing.Color.Yellow;

                        }
                        labelAction.Text = "Running: " + progItem;
                        if (tableCol == 1)
                        {
                            if (compoundStatements[returnRow(line), 0] == 1) //Start of a while loop
                            {
                                x = progItem.Split('('); //Get condition
                                condition = x[1];

                                //Check if condition is true
                                if (condition.Contains("notblocked"))
                                {
                                    if (moveIsValid())
                                    {
                                        line++;
                                    }
                                    else
                                    {
                                        line = compoundStatements[returnRow(line), 2] + 1;
                                    }

                                }
                                else if (condition.Contains("ispainted"))
                                {
                                    if (grid[activeRow, activeColumn].getPaint())
                                    {
                                        line++;
                                    }
                                    else
                                    {
                                        line = compoundStatements[returnRow(line), 2] + 1;
                                    }

                                }
                                else if (condition.Contains("notpainted"))
                                {
                                    if (!grid[activeRow, activeColumn].getPaint())
                                    {
                                        line++;
                                    }
                                    else
                                    {
                                        line = compoundStatements[returnRow(line), 2] + 1;
                                    }

                                }
                                else if (condition.Contains("leftblocked"))
                                {
                                    if (direction == 1)
                                    {
                                        if (grid[activeRow - 1, activeColumn].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            line = compoundStatements[returnRow(line), 2] + 1;
                                        }
                                    }
                                    else if (direction == 2)
                                    {
                                        if (grid[activeRow, activeColumn - 1].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            line = compoundStatements[returnRow(line), 2] + 1;
                                        }
                                    }
                                    else if (direction == 3)
                                    {
                                        if (grid[activeRow + 1, activeColumn].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            line = compoundStatements[returnRow(line), 2] + 1;
                                        }
                                    }
                                    else
                                    {
                                        if (grid[activeRow, activeColumn + 1].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            line = compoundStatements[returnRow(line), 2] + 1;
                                        }
                                    }

                                }
                            }
                            else if (compoundStatements[returnRow(line), 0] == 2) //Start of an if statement
                            {

                                x = progItem.Split('('); //Get condition
                                condition = x[1];

                                //Check if condition is true
                                if (condition.Contains("notblocked"))
                                {
                                    if (moveIsValid())
                                    {
                                        line++;
                                    }
                                    else
                                    {
                                        runElse = true;
                                        line = compoundStatements[returnRow(line), 2];
                                    }

                                }
                                else if (condition.Contains("ispainted"))
                                {
                                    if (grid[activeRow, activeColumn].getPaint())
                                    {
                                        line++;
                                    }
                                    else
                                    {
                                        runElse = true;
                                        line = compoundStatements[returnRow(line), 2];
                                    }

                                }
                                else if (condition.Contains("notpainted"))
                                {
                                    if (!grid[activeRow, activeColumn].getPaint())
                                    {
                                        line++;
                                    }
                                    else
                                    {
                                        runElse = true;
                                        line = compoundStatements[returnRow(line), 2];
                                    }

                                }
                                else if (condition.Contains("leftblocked"))
                                {
                                    if (direction == 1)
                                    {
                                        if (grid[activeRow - 1, activeColumn].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            runElse = true;
                                            line = compoundStatements[returnRow(line), 2];
                                        }
                                    }
                                    else if (direction == 2)
                                    {
                                        if (grid[activeRow, activeColumn - 1].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            runElse = true;
                                            line = compoundStatements[returnRow(line), 2];
                                        }
                                    }
                                    else if (direction == 3)
                                    {
                                        if (grid[activeRow + 1, activeColumn].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            runElse = true;
                                            line = compoundStatements[returnRow(line), 2];
                                        }
                                    }
                                    else
                                    {
                                        if (grid[activeRow, activeColumn + 1].getBlocked())
                                        {
                                            line++;
                                        }
                                        else
                                        {
                                            runElse = true;
                                            line = compoundStatements[returnRow(line), 2];
                                        }
                                    }

                                }
                            }
                            else if (compoundStatements[returnRow(line), 0] == 3) //Start of an else statement
                            {
                                if (!runElse) //Go to end of else if it shouldn't be run
                                {
                                    line = compoundStatements[returnRow(line), 2] + 1;
                                }
                                else //Goes to next line to run else
                                {
                                    line++;
                                    runElse = false;
                                }

                            }
                            else //If a for loop
                            {
                                x = progItem.Split(':');
                                condition = x[1];
                                string y = x[0];
                                if (!forLoop)
                                {
                                    forLoop = true;
                                   
                                    startValue = int.Parse(x[0].Split('=')[1]);
                                    if (progItem.Contains('>'))
                                    {
                                        greaterthan = true;
                                    }
                                    else
                                    {
                                        greaterthan = false;
                                    }

                                    if (!progItem.Contains('+'))
                                    {
                                        up = false;
                                    }
                                    else
                                    {
                                        up = true;
                                    }
                                    loopVariable = startValue;
                                    line++;
                                }
                                else
                                {
                                    int endCondition;
                                    if (!greaterthan)
                                    {
                                        endCondition = int.Parse(condition.Split('<')[1]);
                                        if (up)
                                        {
                                            loopVariable++;
                                            if (loopVariable > endCondition)
                                            {
                                                forLoop = false;
                                                line = compoundStatements[returnRow(line), 2] + 1;
                                            }
                                            else
                                            {
                                                line++;
                                            }
                                        }
                                        else
                                        {

                                            loopVariable--;
                                            if (loopVariable > endCondition)
                                            {
                                                forLoop = false;
                                                line = compoundStatements[returnRow(line), 2] + 1;
                                            }
                                            else
                                            {
                                                line++;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        endCondition = int.Parse(condition.Split('>')[1]);
                                        if (up)
                                        {
                                            loopVariable++;
                                            if (loopVariable < endCondition)
                                            {
                                                forLoop = false;
                                                line = compoundStatements[returnRow(line), 2] + 1;
                                            }
                                            else
                                            {
                                                line++;
                                            }
                                        }
                                        else
                                        {
                                            loopVariable--;
                                            if (loopVariable < endCondition)
                                            {
                                                forLoop = false;
                                                line = compoundStatements[returnRow(line), 2] + 1;
                                            }
                                            else
                                            {
                                                line++;
                                            }

                                        }
                                    }

                                }


                            }
                        }
                        else
                        {
                            if (compoundStatements[returnRow(line), 0] == 1) //End of a while
                            {
                                line = compoundStatements[returnRow(line), 1];
                            }
                            else if (compoundStatements[returnRow(line), 0] == 4) //End of for loop
                            {
                                line = compoundStatements[returnRow(line), 1];
                            }
                            else
                            {
                                line = compoundStatements[returnRow(line), 2] + 1;
                            }
                        }
                        await Task.Delay(1000);
                        RTBprog.SelectionBackColor = System.Drawing.Color.Transparent;
                    }
                    else
                    {

                        startIndex = RTBprog.GetFirstCharIndexFromLine(line);
                        RTBprog.Select(startIndex, RTBprog.Lines[line].Length);
                        RTBprog.SelectionBackColor = System.Drawing.Color.Yellow;

                        labelAction.Text = "Running: " + progItem;
                        checkAction(progItem);
                        await Task.Delay(1000);
                        line++;
                        RTBprog.SelectionBackColor = System.Drawing.Color.Transparent;
                    }

                }
                else { line++; }
            }

            if (error)
            {
                labelAction.Text = "Error on line: "+line+" "+prog[line];
            }
            else
            {
                labelAction.Text = "Done Running";
            }

            tableLayoutPanelGrid.BackColor = Color.YellowGreen;
            buttonRun.Enabled = true;
            buttonReset.Enabled = true;
            buttonStep.Enabled = true;
            RTBprog.Enabled = true;
            progDone = true;
            progSet = false;

        }

      
        //************************************* 
        // Helper functions
        //************************************


        //Returns row in compound statements table
        private int returnRow(int lineNum)
        {
            for (int i = 0; i < 10; i++)
            {
                if (compoundStatements[i, 1] == lineNum || compoundStatements[i, 2] == lineNum)
                {
                    return i;
                }

            }
            return -1;
        }

        //Returns true if line number is in the compound statements table
        private bool inTable(int lineNum)
        {
            for (int i = 0; i < 10; i++)
            {
                if (compoundStatements[i, 1] == lineNum)
                {
                    tableRow = i;
                    tableCol = 1;
                    return true;
                }
                else if (compoundStatements[i, 2] == lineNum)
                {
                    tableRow = i;
                    tableCol = 2;
                    return true;
                }
            }

            return false;

        }

        //Creates compound statements table
        private void preCompile()
        {
            int row = 0;
            int col = 0;
            int line = 0;
            int[] close = new int[10]; //Holds lines of closing brackets


            for (int i = 0; i < 10; i++)
            {
                compoundStatements[i, 2] = -1;
                compoundStatements[i, 1] = -1;
                compoundStatements[i, 0] = -1;
            }

            foreach (string progItem in prog)
            {

                if (progItem.Contains("while"))
                {
                    compoundStatements[row, col] = 1; //Shows me it is a while
                    col++;
                    compoundStatements[row, col] = line; //Line number of open
                    row++;


                }
                else if (progItem.Contains("if"))
                {
                    compoundStatements[row, col] = 2; //Shows me it is a if
                    col++;

                    compoundStatements[row, col] = line; //Line number of open
                    row++;


                }
                else if (progItem.Contains("else")) //shows me it is a else
                {
                    compoundStatements[row, col] = 3;
                    col++;

                    compoundStatements[row, col] = line; //Line number of open
                    row++;


                }
                else if (progItem.Contains("for"))
                {
                    compoundStatements[row, col] = 4;//Shows me it is a for
                    col++;

                    compoundStatements[row, col] = line; //Line number of open
                    row++;


                }
                else if (progItem.Contains("}"))
                {
                    //Start at bottom and find the first zero starting at current row

                    for (int i = row - 1; i >= 0; i--)
                    {
                        if (compoundStatements[i, 2] == -1)
                        {
                            compoundStatements[i, 2] = line;
                            break;
                        }
                    }


                }

                line++;

                if (col >= 1) //Reset columns if row is done
                {
                    col = 0;
                }
            }

            progLength = line;

        }

        //Returns next row in current direction
        private int nextRow()
        {
            if (direction == 2)
            {
                return activeRow - 1;
            }
            else if (direction == 4)
            {
                return activeRow + 1;
            }
            else
            {
                return activeRow;
            }
        }

        //Returns next col in current direction
        private int nextCol()
        {
            if (direction == 1)
            {
                return activeColumn + 1;
            }
            else if (direction == 3)
            {
                return activeColumn - 1;
            }
            else
            {
                return activeColumn;
            }
        }

        //Checks if next move in direction is blocked
        private bool moveIsValid()
        {
            int r = nextRow();
            int c = nextCol();
            if ((r <= gridSize - 1 && r >= 0) && (c <= gridSize - 1 && c >= 0)) //Make sure move is not out of range
            {

                if (grid[r, c].getBlocked())//Make sure move is not blocked
                {
                    return false;
                }
                else
                {
                    return true;
                }
            }
            else
            {
                return false;
            }
        }

        //Resets the grid
        public void resetGrid()
        {
            line = 0;
            tableLayoutPanelGrid.BackColor = Color.DarkGray;
            error = false;
            foreach (box b in grid) //Reset each box
            {
                b.reset();
            }

            grid[6, 0].setImage(karela); //Reset Karela to start
            activeColumn = 0;
            activeRow = 6;
            while (direction != 1)
            {
                turn();
            }



        }

        //Checks action and calls specific action function
        public void checkAction(string action)
        {
            if (action.Contains("move")) { move(); }
            else if (action.Contains("turnleft")) { turn(); }
            else if (action.Contains("turnright")) { turnRight(); }
            else if (action.Contains("turnaround")) { turnAround(); }
            else if (action.Contains("paint"))
            {
                if (!grid[activeRow, activeColumn].getPaint())
                {
                    grid[activeRow, activeColumn].setImage(KarelaPaint);
                    grid[activeRow, activeColumn].setPaint();
                }
            }
            else if (action.Contains("erase"))
            {
                grid[activeRow, activeColumn].setImage(karela);
                grid[activeRow, activeColumn].setPaint();
            }
        }

       
        //************************************* 
        // Movement functions
        //************************************
        public void turn()
        {
            if (grid[activeRow, activeColumn].getPaint())
            {
                karela.RotateFlip(RotateFlipType.Rotate270FlipNone);
                KarelaPaint.RotateFlip(RotateFlipType.Rotate270FlipNone);
                grid[activeRow, activeColumn].setImage(KarelaPaint);

            }
            else
            {
                karela.RotateFlip(RotateFlipType.Rotate270FlipNone);
                KarelaPaint.RotateFlip(RotateFlipType.Rotate270FlipNone);
                grid[activeRow, activeColumn].setImage(karela);
            }
            if (direction + 1 <= 4)
            {
                direction++;
            }
            else
            {
                direction = 1;
            }

        }
        public void turnRight()
        {
            turn();
            turn();
            turn();
        }
        public void turnAround()
        {
            turn();
            turn();
        }
        public void move()
        {


            if (moveIsValid())
            {
                int r = nextRow();
                int c = nextCol();
                if (grid[activeRow, activeColumn].getPaint())
                {
                    grid[activeRow, activeColumn].setImage(painted);
                }
                else
                {
                    grid[activeRow, activeColumn].setImage(blank);
                }


                if (grid[r, c].getPaint())
                {
                    grid[r, c].setImage(KarelaPaint);
                }
                else
                {
                    grid[r, c].setImage(karela);
                }

                activeRow = r;
                activeColumn = c;

            }
            else
            {
                error = true;
            }
        }

        //************************************* 
        // Lesson 
        //************************************

        //Opens lesson form on button click
        private void buttonLesson_Click(object sender, EventArgs e)
        {
            Lesson l = new Lesson(this, lesson);
            l.Show();

        }

        //Changes what lesson is selected
        private void listBoxLessons_SelectedIndexChanged(object sender, EventArgs e)
        {
            string selectedLesson = listBoxLessons.SelectedItems[0].ToString();
            if (selectedLesson == "Introduction")
            {
                lesson = 0;
            }
            if (selectedLesson == "Lesson 1")
            {
                lesson = 1;
            }
            else if (selectedLesson == "Lesson 2")
            {
                lesson = 2;
            }
            else if (selectedLesson == "Lesson 3")
            {
                lesson = 3;
            }
            else if (selectedLesson == "Lesson 4")
            {
                lesson = 4;
            }
            else if (selectedLesson == "Lesson 5")
            {
                lesson = 5;
            }
            else if (selectedLesson == "Lesson 6")
            {
                lesson = 6;
            }
            else if (selectedLesson == "Lesson 7")
            {
                lesson = 7;
            }

        }

        //************************************* 
        // Saving and loading files 
        //************************************

        //Opens save dialog to save program as .txt
        private void buttonSave_Click(object sender, EventArgs e)
        {
            saveFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 2;
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                File.WriteAllText(saveFileDialog1.FileName, RTBprog.Text);
                fileName = saveFileDialog1.FileName;
            }

        }
        private void RTBprog_TextChanged(object sender, EventArgs e)
        {
            fileModified = true;
        }

        //Opens load dialog to load a .txt file
        private void buttonLoad_Click(object sender, EventArgs e)
        {
            string filePath;
            if (!fileModified)
            {
                openFileDialog1.InitialDirectory = "c:\\";
                openFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
                openFileDialog1.FilterIndex = 2;
                openFileDialog1.RestoreDirectory = true;

                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    //Get the path of specified file
                    filePath = openFileDialog1.FileName;
                    RTBprog.Text = File.ReadAllText(filePath);

                }
            }
            else
            {
                DialogResult result = MessageBox.Show(fileName, "Do you wish to save?", MessageBoxButtons.YesNoCancel);
                if (result == DialogResult.Yes)
                {
                    saveFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
                    saveFileDialog1.FilterIndex = 2;
                    if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                    {
                        File.WriteAllText(saveFileDialog1.FileName, RTBprog.Text);
                        fileName = saveFileDialog1.FileName;
                    }

                    fileModified = false;
                }
                else
                {
                    openFileDialog1.InitialDirectory = "c:\\";
                    openFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
                    openFileDialog1.FilterIndex = 2;
                    openFileDialog1.RestoreDirectory = true;

                    if (openFileDialog1.ShowDialog() == DialogResult.OK)
                    {
                        //Get the path of specified file
                        filePath = openFileDialog1.FileName;
                        RTBprog.Text = File.ReadAllText(filePath);
                    }
                }
            }

        }

        //************************************* 
        // Enabling and disabling buttons on focus change
        //************************************
        private void main_Activate(object sender, EventArgs e)
        {
            buttonRun.Enabled = true;
            buttonReset.Enabled = true;
            buttonStep.Enabled = true;
            RTBprog.Enabled = true;
        }
        private void main_Deactivate(object sender, EventArgs e)
        {
            buttonRun.Enabled = false;
            buttonReset.Enabled = false;
            buttonStep.Enabled = false;
            RTBprog.Enabled = false;
        }

        //Opens reference sheet
        private void buttonRef_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(Environment.CurrentDirectory+ "//Karela-References-and-Syntax-Sheet.txt");
        }

       
    }
}
